const User = require("../../models/user");
const bcryptjs= require('bcryptjs');
const JWT = require('jsonwebtoken');
const config =require('../../config')

exports.getUserById = async (req, res) => {
  try {
    const userId = req.params.id;
    const user = await User.findOne({
      where: { id: userId }
    });
    res.status(200).send(user);
  } catch (err) {
    console.log(err);
    res.sendStatus(401);
  }
};
createToken = id => {
  return JWT.sign({ id }, config.JWT_SECRET);
};

exports.register = async (req, res) => {
  try {
    const registerData = req.body;
    const user = await User.findOne({
      where: { email: registerData.email }
    });

    if (user) {
      return res.status(400).json({ message: "อีเมลนี้ถูกใช้งานแล้ว" });
    } else {
      const passwordHash = await bcryptjs.hash(registerData.password, 10);
      const newUser = await User.create({
        name: registerData.name,
        email: registerData.email,
        password: passwordHash
      });
      const token = await createToken(newUser.id);
      res.status(200).send("success");
    }
  } catch (err) {
    console.log(err);
    res.sendStatus(401);
  }
};
